#ifndef __RND_GEN__
#define __RND_GEN__


// Implemented using GMP
typedef struct RndGen RndGen;

// Create a new random generator (with seed = time(NULL))
RndGen* RndGen_new();

// Free memory
void RndGen_free(RndGen** rndPtr);

// (Re-)set seed
void RndGen_setSeed(RndGen* rnd, unsigned long int seed);

// Get seed
unsigned long RndGen_getSeed(RndGen* rnd);


// Get next number as unsigned long between from and to (inclusive)
unsigned long RndGen_nextUL(RndGen* rnd, unsigned long from, unsigned long to);

// Get next number as double between from and to
double RndGen_nextD(RndGen* rnd, double from, double to);

double RndGen_nextDQuantized(RndGen *rnd, double from, double to, int parts);
#endif
