//#define NDEBUG

#include <stdio.h>
#include <unistd.h>

#include <StringUtils.h>
#include <Debug.h>

#include <Numbers.h>

#define DEBUG_THIS "TestNumbers"

int main(int argc, char** args) {

	Debug_assert(DEBUG_THIS, argc >= 3, "Syntax: %s double1 double 2\n", args[0]);
	double d1 = 0, d2 = 0; 
	int err = StringUtils_toDouble(args[1], &d1);
	Debug_assert(DEBUG_THIS, err == 0, "Error while parsing '%s'\n", args[1]);
	err = StringUtils_toDouble(args[2], &d2);
	Debug_assert(DEBUG_THIS, err == 0, "Error while parsing '%s'\n", args[2]);	
	
	d1 = pow(sqrt(d1 * d2 / d2), 2);
	d2 = pow(sqrt(d2 - d1 + d1), 2);
	
	Debug_out(DEBUG_THIS, "- d1 = %lf\n", d1);
	Debug_out(DEBUG_THIS, "- d2 = %lf\n", d2);	
	
	Debug_out(DEBUG_THIS, "- d1 == d2?   %d\n", (d1 == d2));
	Debug_out(DEBUG_THIS, "- d1 ~= d2?   %d\n\n", (Numbers_approxEQ(d1, d2)));	
	
	Debug_out(DEBUG_THIS, "- d1 <= d2?   %d\n", (d1 <= d2));
	Debug_out(DEBUG_THIS, "- d1 <~= d2?  %d\n\n", (Numbers_approxLE(d1, d2)));	

	Debug_out(DEBUG_THIS, "- d1 >~= d2?  %d\n", (Numbers_approxGE(d1, d2)));	
	return 0;
}
