
#include <stdio.h>

#include <Debug.h>
#include <StringUtils.h>

#include <Range_Double.h>

#define DEBUG_THIS "TestRangeDouble"

void scan_iterator(Range_Double_Iterator* it) {
	Range_Double_Iterator_rewind(it);
	double value = 0;
	while (Range_Double_Iterator_next(it, &value)) {
		Debug_out(DEBUG_THIS, " - %lf\n", value);
	}
}


int main(int argc, char** args) {

	Debug_assert(DEBUG_THIS, argc >= 4, "Syntax: %s min max step\n", args[0]);
	double min = 0, max = 0, step = 0; 
	int err = StringUtils_toDouble(args[1], &min);
	Debug_assert(DEBUG_THIS, err == 0, "Error while parsing '%s'\n", args[1]);
	err = StringUtils_toDouble(args[2], &max);
	Debug_assert(DEBUG_THIS, err == 0, "Error while parsing '%s'\n", args[2]);	
	err = StringUtils_toDouble(args[3], &step);
	Debug_assert(DEBUG_THIS, err == 0, "Error while parsing '%s'\n", args[3]);
	
	Range_Double* ri = Range_Double_new(min, max, step);
	fprintf(stderr, "==== TEST NORMAL ITERATOR: START ====\n");	
	Range_Double_Iterator* it = Range_Double_Iterator_new(ri);
	scan_iterator(it);	
	fprintf(stderr, "==== TEST NORMAL ITERATOR: END ====\n");	
	Range_Double_Iterator_free(&it);
	
	fprintf(stderr, "==== TEST FLIPPING ITERATOR: START ====\n");	
	it = Range_Double_Iterator_new_flipping(ri);
	scan_iterator(it);	
	fprintf(stderr, "==== TEST FLIPPING ITERATOR: END ====\n");		
	Range_Double_Iterator_free(&it);
	
	Range_Double_free(&ri);
	return 0;
}
